#if !defined(__linux__) /* for error */
#include <string.h>
#endif
#include <sys/types.h>

#include <nllibc.h>

size_t strlen(const char *s)
{
  int len;
  for (len = 0; s[len]; len++)
    ;
  return len;
}

char *strcpy(char *dst, const char *src)
{
  int i;
  for (i = 0; src[i]; i++)
    dst[i] = src[i];
  dst[i] = '\0';
  return dst;
}

char *strcat(char *s, const char *append)
{
  strcpy(s + strlen(s), append);
  return s;
}

int strcmp(const char *s1, const char *s2)
{
  while (*s1 || *s2) {
    if (*s1 < *s2) return -1;
    if (*s1 > *s2) return  1;
    s1++;
    s2++;
  }
  return 0;
}

void *memset(void *dest, int c, size_t len)
{
  int i;
  char *s = dest;
  for (i = 0; i < len; i++)
    s[i] = c;
  return dest;
}

void *memcpy(void *dst, const void *src, size_t len)
{
  int i;
  char *d = dst;
  const char *s = src;
  for (i = 0; i < len; i++)
    d[i] = s[i];
  return dst;
}

void *memmove(void *dst, const void *src, size_t len)
{
  int i;
  char *d = dst;
  const char *s = src;
  if (d < s) {
    for (i = 0; i < len; i++)
      d[i] = s[i];
  } else {
    for (i = 0; i < len; i++)
      d[len - (i + 1)] = s[len - (i + 1)];
  }
  return dst;
}
