#if defined(__FreeBSD__) || defined(__OpenBSD__) || defined(__NetBSD__) || defined(__DragonFly__) || defined(__APPLE__)
#if defined(__i386__)

/*
 * Use FreeBSD/NetBSD system call.
 */

#define SYS_exit   1
#define SYS_read   3
#define SYS_write  4
#define SYS_open   5
#define SYS_close  6
#define SYS_ioctl 54

	.section .text

	.globl	_exit
	.type	_exit, @function
_exit:
	mov	$SYS_exit, %eax
	jmp	_syscall

	.globl	read
	.type	read, @function
read:
	mov	$SYS_read, %eax
	jmp	_syscall

	.globl	write
	.type	write, @function
write:
	mov	$SYS_write, %eax
	jmp	_syscall

	.globl	open
	.type	open, @function
open:
	mov	$SYS_open, %eax
	jmp	_syscall

	.globl	close
	.type	close, @function
close:
	mov	$SYS_close, %eax
	jmp	_syscall

	.globl	ioctl
	.type	ioctl, @function
ioctl:
	mov	$SYS_ioctl, %eax
	jmp	_syscall

_syscall:
	int	$0x80
	jnc	ret
err:	mov	%eax, errno 
	mov	$-1, %eax
ret:	ret
#endif
#endif
